<%Option Explicit%>
<!-- #include file="../../Includes/Request_Start.inc.asp" -->
<script runat="server" language="jscript" src="../../Includes/dataGrid2.js"></script>
<script runat="server" language="vbscript" src="../../Includes/SessionValidator.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/CheckHeader.vbs"></script>
<%
CheckHeader "myarticles.aspx"
ValidateSession

If Len(Request.QueryString("unsubmit")) Then
		With Server.CreateObject("ADODB.Command")
			.ActiveConnection = Application("ConnectionString")
			.CommandText = _
				"UPDATE [Articles] " & _
				"   SET [Status] = 'Incomplete', " & _
				"       [Submission Date] = NULL " & _
				" WHERE [Article Id] = ? " & _
				"   AND [Username] = ? " & _
				"   AND [Status] = 'Submitted' "
			.Parameters.Append .CreateParameter("ArticleId", adInteger, adParamInput, 4, CLng(Request.QueryString("unsubmit")))
			.Parameters.Append .CreateParameter("Username", adVarChar, adParamInput, 50, Session("Username"))
			.Execute
		End With	
End If

%>


<div id="maincontent">
<h1>My Articles</h1>	
<p></p>
<div style="margin-top:10px;"><%RenderDataGrid%></div>
<% Sub DisplayNoArticleCopy() %>
<div style="margin-top:10px;">Thanks for your interest in writing an article for ChooseYourStory. In addition to helping out
other members, you'll be awarded 50 points if your article is accepted. Read some of the articles on the site to get an idea of what yours should look like.</div>
<% End Sub %>
<div style="margin-top:10px;"><input type="button" onClick="location='editArticle.aspx';" value="Write New Article"/></div>

	  </div>
<% Server.Execute(Application("SiteRoot") & "Includes/footer.asp") %>
<script runat="server" language="jscript">
function RenderDataGrid()
{
	var cmd = new ActiveXObject("ADODB.Command");
	cmd.ActiveConnection = Application("ConnectionString");
	cmd.CommandText = 
			"SELECT [Article Id], " +
			"       [Status], " +			
			"       [Title] = COALESCE([Title],'(untitled)'), " +
			"       [Article Status] = " +
			"         [Status] + COALESCE(" + 
			"           ' on ' + CONVERT(VARCHAR(10),[Submission Date],1), " +
			"           ' on ' + CONVERT(VARCHAR(10),[Acceptance Date],1), " +
			"           '' " +
			"         ) " +
			" FROM [Articles] " +
			" WHERE [Username] = ?";
	cmd.Parameters.Append(cmd.CreateParameter("Username",adVarChar,adParamInput,20,Session("Username")));
	var rs = cmd.Execute();
	
	if (rs.EOF)
	{
		DisplayNoArticleCopy();
		return;
	}
	
	var dg = new DataGrid(rs);
	for (var i=0;i<dg.Columns.length;i++) dg.Columns[i].HeadingAlign="left";

	dg.Columns["Article Id"].Visible = false;
	dg.Columns["Status"].Visible = false;	
	dg.Columns["Title"].RenderText = function() 
	{
		var articleId = dg.Columns[0].GetValue();
		var title = this.GetValue();
		var status = dg.Columns[1].GetValue();
		
		if (status=='Incomplete') 
			return '<a href="editArticle.aspx?ArticleId=' + articleId + '">' + title + '</a>';
		else
		{
			var ret = '<a href="article.aspx?ArticleId=' + articleId + '">' + title + '</a>';
			if (status=='Submitted')
				ret += '&nbsp;<a href="?unsubmit=' + articleId + '">[unsubmit]</a>';
			return ret;
		}
	}
	
	dg.Display();

}
</script>