<%option explicit%>
<!-- #include file="../../Includes/Request_Start.inc.asp" -->
<script runat="server" language="vbscript" src="../../Includes/gameValidator.vbs"></script>
<script runat="server" language="jscript" src="../../Includes/dataGrid2.js"></script>
<script runat="server" language="vbscript" src="../../Includes/helperFunctions.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/CheckHeader.vbs"></script>
<script runat="server" language="vbscript" src="navigation.vbs"></script><%
CheckHeader "Chapters.aspx"

Dim Action : Action = LCase(Request.Form("pbAction"))
Dim Value : Value = Request.Form("pbValue")
Dim IsPostBack : IsPostBack = _
    Request.Form("postback") = Request.ServerVariables("SCRIPT_NAME")
Dim GameID : If Len(Request.Form("GameID")) _
	Then GameID = CLng(Request.Form("GameID")) _
	Else GameID = CLng(Request.QueryString())
Dim ChapterId : If Len(Request.Form("ChapterId")) Then ChapterId = CLng(Request.Form("ChapterId"))

Dim Conn
	Set Conn = Server.CreateObject("ADODB.Connection")
	Conn.Open Application("ConnectionString")

ValidateGameWithConn GameID,Conn

Select Case Action
  Case "nav" : Navigate Value,GameID
  Case "sel_chap" : ChapterId = CLng(Value)
  Case "delete_page" : DeletePAge GameId, CLng(Value)
  Case "delete_chapter" : DeleteChapter GameId, ChapterId
  Case "save" : Save
  Case "create_chapter" : CreateChapter GameId, Value
  Case "create_page" : CreatePage GameId, ChapterId, Value
End Select

	Dim scriptingLevel
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Application("ConnectionSTring")
		.CommandText = "ChooseYourStory.dbo.Story_Editing_GetEditorOptions"
		.CommandType = adCmdStoredProc
		.Parameters.Append .CreateParameter("@StoryId",adInteger,adParamInput,4,GameId)
		.Parameters.Append .CreateParameter("@User_Username",adVarChar,adParamInput,20,Session("Username"))
		With .Execute
			scriptingLevel = .Fields("Scripting_Level")
		End With
	End With

Dim DisplayDeleteChapter

Dim ChapterTitle, StartPage, Pages

With Server.CreateObject("ADODB.Command")
	.ActiveConnection = Conn
	.CommandText = _
		"SELECT TOP 1 C.[Chapter Id], C.[Title], S.[Page Id] " & _
		"  FROM [Game Chapters] C " & _
		"       LEFT JOIN [Game Chapter Start Pages] S " & _
		"              ON S.[Game Id] = C.[Game Id] " & _
		"             AND S.[Chapter Id] = C.[Chapter Id] " & _
		" WHERE C.[Game Id] = ? "
	If Not IsEmpty(ChapterId) Then .CommandText = .CommandText & _
		"   AND C.[Chapter Id] = ? "
	.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)	
	If Not IsEmpty(ChapterId) Then .Parameters.Append .CreateParameter("ChapterId",adInteger,adParamInput,4,ChapterId)	
	With .Execute
		If Not .EOF Then
			ChapterId = .Fields("Chapter Id")
			ChapterTitle = .Fields("Title")
			StartPage = .Fields("Page Id")
			.MoveNext
		End If
	End With
End With

If Not IsEmpty(ChapterTitle) Then Set Pages = CreateDataGrid(GameId, ChapterId,Conn, scriptingLevel<>"Disabled")

%>




<div id="MainContent">
<h1>Advanced Editor &raquo; Chapters</h1>
<% WriteSecondaryNavigation %>
		
	<form name="mainForm" method="post" style="margin: 15px 0px 0px 0px; ">
	  <input type="hidden" name="pbAction" value="">
	  <input type="hidden" name="pbValue" value="">
 	  <input type="hidden" name="GameID" value="<%=GameID%>">
 	  <input type="hidden" name="ChapterId" value="<%=ChapterId%>">	  
	  <input type="hidden" name="NewVariable" value="">
            <input type="hidden" name="postback" value="<%=Request.ServerVariables("SCRIPT_NAME") %>" />


	<table style="margin-top: 5px; " cellpadding="5" cellspacing="0" border="0">
	  <tr>
	    <td style="border:1px solid black; padding:3px; padding-left:0px; border-left-width: 0px;">
	      <div style="line-height:16pt "><% WriteChapterList %></div>
	      <div align="right"><a href="#" onClick="createNewChapter();" class="smallerText">[create new chapter]</a></div>
		</td>
	  </tr>
	</table>	
		<p class="smallerText">Chapters are used to help you, as an author, organize the pages in 
	your games. The player of your game will never see chapters.</p>


<% If Not IsEmpty(ChapterId) Then %>
	<hr>
	<h1><%=ChapterTitle%></h1>
		<table border="0" cellpadding="0" cellspacing="0">
		<tr>
			<% If scriptingLevel<>"Disabled" Then %>
		  <td><label>Id</label></td>
		  <td><img src="../../i/spacer.gif" height="1" width="10"/></td>
		  <%End IF %>			
		  <td><label>Chapter Title</label></td>
		  <td><img src="../../i/spacer.gif" height="1" width="10"/></td>
		  <td><label>Chapter Start Page</label></td>
		  </tr>
		<tr>
			<% If scriptingLevel<>"Disabled" Then %>
		  <td><%=ChapterId %></td>
		  <td><img src="../../i/spacer.gif" height="1" width="10"/></td>
		  <%End IF %>	
		  <td><input onChange="dataChanged=true;" type="text" name="Title" maxlength="25" size="25" value="<%=Server.HTMLEncode(ChapterTitle)%>" /></td>
		  <td>&nbsp;</td>
		  <td><select name="Start Page" onChange="dataChanged=true;" class="smallerText">
		  <option value=""></option>
			<%
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = _
			"SELECT P.[Page Id], P.[Title] AS [Title]"  & vbCrLf & _
			"  FROM [Game Pages] P"  & vbCrLf & _
			" WHERE P.[Game Id]=? AND P.[Chapter Id] = ?"  & vbCrLf & _
			" ORDER BY P.[Page Id]"
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameId)	
		.Parameters.Append .CreateParameter("ChapterId",adInteger,adParamInput,4,ChapterId)		
		With .Execute
			Do While Not .EOF
				Response.Write "<option "
				If .Fields("Page ID") = StartPage Then Response.Write " selected='true' "
				Response.Write "value=""" & .Fields("Page ID").Value & """>" & _
					"[#" & .Fields("Page ID").Value & "] " & .Fields("Title").Value & "</option>"
			  .MoveNext()
			Loop
		End With 	
	End With
	%>
		  </select></td>
		  </tr>
		<tr>
		  <td><img src="../../i/spacer.gif" height="5" width="1"/></td>
		  </tr>
		<tr>
		  <td colspan="5"><input type="button" onClick="PostBack('save');" value="Save Changes to Chapter" />	    
			&nbsp;&nbsp;
			<% If DisplayDeleteChapter Then %>
			  <input type="button" onClick="if (confirm('Are you sure you want to delete this chapter?\nThis will delete all pages contained within.\n\n This cannot be undone.')) PostBack('delete_chapter');" value="Delete Entire Chapter" /></td>
			<% Else %>
			  <input type="button" onClick="alert('Whoops!\n You\'re not allowed to delete the first chapter.');" value="Delete Entire Chapter" /></td>
			<% End If %>
		  </tr>
		</table>
		
		
		<h2 style="margin: 10px 0px 5px 0px;">Pages in <%=ChapterTitle%></h2>
        <input style="margin-bottom: 0.5rem; margin-top: 0.5rem;" type="button" value="Create New Page" onClick="createNewPage();">
		<% Pages.Display %>
		<input style="margin-bottom: 0.5rem; margin-top: 0.5rem;" type="button" value="Create New Page" onClick="createNewPage();">
<% End If %>		
		
	</form>	
</div>
<% Server.Execute(Application("SiteRoot") & "Includes/footer.asp") 

Conn.Close

Sub WriteChapterList
	Dim sep, linelen, first : first = True
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = _
			"SELECT C.[Chapter Id], C.[Title] " & _
			"  FROM [Game Chapters] C " & _
			" WHERE C.[Game Id] = ? " 
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)	
		With .Execute
			Do While Not .EOF
				Response.Write sep
				Response.Write "<span"
				If ChapterId = .Fields("Chapter Id").Value Then
					Response.Write " class=""tertiaryButtonSelected"""
					DisplayDeleteChapter = Not first
				Else
					Response.Write " class=""tertiaryButton"" style=""cursor:pointer;"""
					Response.Write " onClick=""PostBack('sel_chap'," & .Fields("Chapter Id").Value & ");"""
				End If
				Response.Write ">" & .Fields("Title").Value &  "</span>"
				linelen = linelen + Len(.Fields("Title").Value)
				If linelen > 55 Then
					sep = "<br/>"
					linelen = 0
				Else
					sep = "&nbsp;|&nbsp;"
				End If
				first = False
				.MoveNext
			Loop
		End With
	End With		
End Sub

Sub DeletePage( GameId, PageId )
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = _
			"DELETE FROM [Game Pages] " & _
			" WHERE [Game Id] = ? " & _
			"   AND [Page Id] = ? "
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)	
		.Parameters.Append .CreateParameter("PageId",adInteger,adParamInput,4,PageId)	
		.Execute
	End With		
End Sub

Sub DeleteChapter( GameId, ChapterId )
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = _
			"DELETE FROM [Game Chapters] " & _
			" WHERE [Game Id] = ? " & _
			"   AND [Chapter Id] = ? "
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)	
		.Parameters.Append .CreateParameter("ChapterId",adInteger,adParamInput,4,ChapterId)	
		.Execute
	End With		
	ChapterId = Empty
End Sub

Sub Save()

	Dim RecordsAffected
	
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = _
			"UPDATE [Game Chapters] " & _
			"   SET [Title] = ? " & _
			" WHERE [Game Id] = ? " & _
			"   AND [Chapter Id]= ? "
		.Parameters.Append .CreateParameter("Title",adVarChar,adParamInput,250,Request.Form("Title"))
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)	
		.Parameters.Append .CreateParameter("ChapterId",adInteger,adParamInput,4,ChapterId)	
		If Len(.Parameters("Title").Value) = 0 Then .Parameters("Title").Value = "(empty)"
		.Execute RecordsAffected
	End With
	
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = _
			"DELETE [Game Chapter Start Pages] " & _
			" WHERE [Game Id] = ? " & _
			"   AND [Chapter Id]= ? "
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)	
		.Parameters.Append .CreateParameter("ChapterId",adInteger,adParamInput,4,ChapterId)	
		.Execute RecordsAffected
	End With
	
	If Request.Form("Start Page") = "" Then Exit Sub

	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = _
			"INSERT INTO [Game Chapter Start Pages] " & _
			"   ([Game Id], [Chapter Id], [Page Id])  " & _
			" VALUES (?, ?, ?) "
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)	
		.Parameters.Append .CreateParameter("ChapterId",adInteger,adParamInput,4,ChapterId)	
		.Parameters.Append .CreateParameter("PageId",adInteger,adParamInput,4,Request.Form("Start Page"))	
		.Execute
	End With	
End Sub

Sub CreateChapter(GameId, Title)
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandType = adCmdStoredProc
		.CommandText = "[Create New Chapter]"
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)	
		.Parameters.Append .CreateParameter("Title",adVarChar,adParamInput,50,Title)	
		.Parameters.Append .CreateParameter("ChapterId",adInteger,adParamOutput,4)	
		.Execute
		ChapterId = .Parameters("ChapterId").Value
	End With		
End Sub

Sub CreatePage(GameId, ChapterId, Title)
	Dim PageId
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = "[Create New Page]"
		.CommandType = adCmdStoredProc
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,8,GameID)
		.Parameters.Append .CreateParameter("ChapterId",adInteger,adParamInput,8,ChapterId)
		.Parameters.Append .CreateParameter("Title",adVarChar,adParamInput,250,Title)
		.Parameters.Append .CreateParameter("PageID",adInteger,adParamOutput,8)
		.Execute
		PageId = .Parameters("PageID").Value
	End With
	Response.Write "<script defer>editPage(" & GameId & "," & PageId & ");</script>"
End Sub

%><script runat="server" language="jscript">
function CreateDataGrid(GameId, ChapterId, Conn, dispIds)
{
	var cmd = new ActiveXObject("ADODB.Command");
	
	cmd.ActiveConnection = Conn;
	cmd.CommandText = 
	 	"SELECT NULL [Edit Button], NULL [Delete Button], [Page Id], [Title] AS [Page Title], " +
		"       CAST([Content] AS VARCHAR(250)) [Content] " +
		"  FROM [Game Pages] " +
		" WHERE [Game Id] = ? " +
		"   AND [Chapter Id] = ? " +
		" ORDER BY [Page Id]";
	cmd.Parameters.Append( cmd.CreateParameter("GameId", adInteger, adParamInput, 4, GameId) );
	cmd.Parameters.Append( cmd.CreateParameter("ChapterId", adInteger, adParamInput, 4, ChapterId) );	

	var dg = new DataGrid(cmd.Execute);
	dg.ShowHeadings = false;
	dg.CellPadding = 5;

	dg.Columns["Page Id"].Visible = false;
	dg.Columns["Content"].Visible = false;
	dg.Columns["Edit Button"].RenderText = function() 
	{ 
		return '<img src="images/edit.gif" width="12" height="12" style="cursor:pointer;" alt="Edit Page"' +
				' onclick="editPage(' + GameId + ',' + dg.Columns["Page Id"].GetValue() + ');" />';
	}

	dg.FirstRow = true;
	dg.Columns["Delete Button"].RenderText = function() 
	{ 
		if (dg.FirstRow==true && false)  //changed this rule for now
		{
			dg.FirstRow = false
			return '<img src="images/delete.gif" width="12" height="12" style="cursor:pointer;" alt="Delete Page" ' +
				'onclick="' +
				"alert('Whoops!\\n You\\'re not allowed to delete the first page in a chapter.');" +
				'">'
		}
		else
		{
			return '<img src="images/delete.gif" width="12" height="12" style="cursor:pointer;" alt="Delete Page" ' +
				'onclick="' +
				"if (confirm('Are you sure you want to delete this page?\\n\\nThis cannot be undone.')) PostBack('delete_page','" + dg.Columns["Page Id"].GetValue() + "');" +
				'">'		
		}
	}
	dg.Columns["Page Title"].WriteText = function()
	{
		Response.Write(
			( (dispIds) ? ("[#" + dg.Columns["Page Id"].GetValue() + "] ") : "" ) + 
			'<b>' + dg.Columns["Page Title"].GetValue() + "</b>" +
			"<br/>" + 
			stripHTML(dg.Columns["Content"].GetValue()) + '...'
			);
	}

	dg.Columns["Page Title"].CssClass ='smallerText';

	return dg;

}
</script>
