<% option explicit %>
<!-- #include file="../../Includes/Request_Start.inc.asp" -->
<script runat="server" language="vbscript" src="navigation.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/gameValidator.vbs"></script>
<script runat="server" language="jscript" src="../../Includes/dataGrid2.js"></script>
<script runat="server" language="vbscript" src="../../Includes/fckeditor.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/CheckHeader.vbs"></script>
<%
CheckHeader "Item.aspx"

Dim Action : Action = LCase(Request.Form("pbAction"))
Dim Value : Value = Request.Form("pbValue")
Dim IsPostBack : IsPostBack = _
    Request.Form("postback") = Request.ServerVariables("SCRIPT_NAME")
Dim GameID : If Len(Request.Form("GameID")) _
	Then GameID = CLng(Request.Form("GameID")) _
	Else GameID = CLng(Request.QueryString("GameID"))
Dim ItemID : If Len(Request.Form("ItemID")) _
	Then ItemID = CLng(Request.Form("ItemID")) _
	Else ItemID = CLng(Request.QueryString("ItemID"))

	
Dim Conn
	Set Conn = Server.CreateObject("ADODB.Connection")
	Conn.Open Application("ConnectionString")

	
ValidateGameWithConn GameID, Conn

If IsPostBack Then Save

Select Case Action
	Case "save" : Navigate "items", GameId
	Case "nav" : Navigate Value,GameID
	Case "delete_effect" : DeleteEffect GameId, ItemId, CLng(Value)
	Case "save_effect" : SaveEffect GameId, ItemId, CLng(Value), Request.Form("Destination")
End Select		

 With Conn.Execute( _
			"SELECT [Page Id], [Title], [Description], [Image Id], " & _
			"       [Number of Uses], [Is Droppable], " & _
			"       [Default Destination Type], [Default Destination] " & _
			"  FROM [Game Items] " & _
			"WHERE [Game ID]=" & GameID & " AND [Item Id]=" & ItemID)

	Dim PageId, Title, Description, ImageId, _
		NumberofUses, IsDroppable, _
		DefaultDestinationType, DefaultDestination 	
	If Not .EOF Then
		PageId = .Fields("Page ID").Value
		Title  = .Fields("Title").Value
		Description  = .Fields("Description").Value	
		If Not IsNull(.Fields("Image Id").Value) Then ImageId = .Fields("Image Id").Value
		If Not IsNull(.Fields("Number of Uses").Value) Then NumberofUses = .Fields("Number of Uses").Value	
		IsDroppable  = .Fields("Is Droppable").Value		
		If Not IsNull(.Fields("Default Destination Type").Value) Then DefaultDestinationType = .Fields("Default Destination Type").Value	
		If Not IsNull(.Fields("Default Destination").Value) Then DefaultDestination = .Fields("Default Destination").Value			
	End If
	
End With

	Dim scriptingLevel, itemLevel
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = "ChooseYourStory.dbo.Story_Editing_GetEditorOptions"
		.CommandType = adCmdStoredProc
		.Parameters.Append .CreateParameter("@StoryId",adInteger,adParamInput,4,GameId)
		.Parameters.Append .CreateParameter("@User_Username",adVarChar,adParamInput,20,Session("Username"))
		With .Execute
			itemLevel = .Fields("Item_Level")
			scriptingLevel = .Fields("Scripting_Level")
		End With
	End With

Dim ItemEffects : Set ItemEffects = CreateDataGrid(Conn, GameId, ItemId)
%>

        <div id="mainContent">
		<h1>Advanced Editor &raquo; Items</h1>		
		<% WriteSecondaryNavigation %>		
		
          <form name="mainForm" method="post"> 
          <h2>Add / Edit Item</h2>
            <p> 
              <label>Title</label> 
              <br/> 
              <input onChange="dataChanged=true;" type="text" name="Title" maxlength="100" size="75" value="<%=Server.HTMLEncode(Title)%>" autofocus="true">
              <br/> 
            </p> 
            <p> 
              <label>Description</label> 
              <br/> 
              <%  
			With (New FCKeditor)
				.Width = "85%"
				.Value = Description
				.Create "Description"
			End With
			%> 
            </p> 
<p> 
              <label>Page Found On</label> 
              <br/> 
              <select name="Page Id" onChange="dataChanged=true;" class="smallerText"> 
                <option value="">&lt;none&gt;</option> 
                <%
With Server.CreateObject("ADODB.Command")
	.ActiveConnection = Conn
	.CommandText = _
		"SELECT P.[Page Id], C.[Title] + ': ' +  P.[Title] AS [Title]"  & vbCrLf & _
		"  FROM [Game Chapters] C"  & vbCrLf & _
		"	   INNER JOIN [Game Pages] P"  & vbCrLf & _
		"			   ON C.[Game Id] = P.[Game Id]"  & vbCrLf & _
		"			  AND C.[Chapter Id] = P.[Chapter Id]"  & vbCrLf & _
		" WHERE P.[Game Id]=?"  & vbCrLf & _
		" ORDER BY C.[Chapter Id], P.[Page Id]"
	.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameId)	
	With .Execute
		Do While Not .EOF
			Response.Write "<option "
			If .Fields("Page ID") = PageID Then Response.Write " selected='true' "
			Response.Write "value=""" & .Fields("Page ID").Value & """>" & _
				.Fields("Title").Value & "</option>"
		  .MoveNext()
		Loop
	End With 	
End With
%> 
              </select> 
            </p>
            <table border="0" cellspacing="0" cellpadding="0">
              <tr>
                <td><label>Number of Uses</label></td>
                <td>&nbsp;&nbsp;&nbsp;&nbsp;</td>
                <td><label>Picture</label></td>
                <td>&nbsp;&nbsp;&nbsp;&nbsp;</td>
                <td><span class="smallerText">
                  <label>Can Be Dropped </label>
                </span></td>
              </tr>
              <tr>
                <td>                  <select name="Number of Uses" onChange="dataChanged=true;">
                    <option value="">Unlimited</option>
                    <option value="1" <%If NumberofUses=1 Then Response.Write " selected='true'"%>>1 Time</option>
                    <%	Dim i : For i = 2 to 100 %>
                    <option value="<%=i%>"<%If NumberofUses=i Then Response.Write " selected='true'"%>><%=i%> Times</option>
                    <% Next %>
                                  </select>                </td>
                <td>&nbsp;</td>
                <td>                  <select name="Image Id" onChange="dataChanged=true;">
                    <option value="">&lt;Generic Item&gt;</option>
                    <%
With Server.CreateObject("ADODB.Command")
	.ActiveConnection = Conn
	.CommandText = _
		"SELECT I.[Image Id], I.Title, "  & vbCrLf & _
		"       CASE WHEN GI.[Image Id] IS NULL THEN '' "  & vbCrLf & _
		"            ELSE 'selected=""true""' END Selected"   & vbCrLf & _
		"  FROM [User Images] U "   & vbCrLf & _
		"       INNER JOIN [Images] I "   & vbCrLf & _
		"               ON U.[Image Id] = I.[Image ID]  "  & vbCrLf & _
		"              AND U.[Username] = ? "  & vbCrLf & _		
		"       LEFT JOIN [Game Items] GI "   & vbCrLf & _
		"               ON I.[Image Id] = GI.[Image ID]  "   & vbCrLf & _		
		"              AND GI.[Game Id] = ? "  & vbCrLf & _		
		"              AND GI.[Item Id]= ?  " 
	.Parameters.Append .CreateParameter("Username",adVarChar,adParamInput,50,Session("Username"))
	.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameId)	
	.Parameters.Append .CreateParameter("ItemID",adInteger,adParamInput,4,ItemID)		
	With .Execute
		Do While Not .EOF
			Response.Write _
				"<option " & .Fields("Selected").Value & "value=""" & .Fields("Image ID").Value & """>" & _
				.Fields("Title").Value & "</option>"
		  .MoveNext()
		Loop
	End With 	
End With
%>
                                  </select>                </td>
                <td class="smallerText">&nbsp;</td>
                <td class="smallerText">                                    <input type="radio" name="Is Droppable" value="1" <%If IsDroppable Then Response.Write " checked"%>/>
  Yes
  <input type="radio" name="Is Droppable" value="0" <%If Not IsDroppable Then Response.Write " checked"%>/>
  No</td>
              </tr>
            </table>
            <p> 
            <h2>Item Effects</h2>
			<p  style="margin-top: 0px; " class="smallerText">An "Item Effect" describes what page to go to if the item is used on a given page.</p>
			<%ItemEffects.Display%>
			<a href="#" onClick="editEffectPopup(<%=GameId %>,<%=ItemId %>);" class="smallerText">[Add New Effect]</a>
            </p> 
            <label>Default Effect</label>
			<div class="smallerText">If an effect has not been defined for the current page, then the player will be taken here when they use the item.</div>

             <select name="Default Destination" onChange="dataChanged=true;" class="smallerText"> 
                <option value="">&lt;none&gt;</option> 
                <%
With Server.CreateObject("ADODB.Command")
	.ActiveConnection = Conn
	.CommandText = _
		"SELECT P.[Page Id], C.[Title] + ': ' +  P.[Title] AS [Title]"  & vbCrLf & _
		"  FROM [Game Chapters] C"  & vbCrLf & _
		"	   INNER JOIN [Game Pages] P"  & vbCrLf & _
		"			   ON C.[Game Id] = P.[Game Id]"  & vbCrLf & _
		"			  AND C.[Chapter Id] = P.[Chapter Id]"  & vbCrLf & _
		" WHERE P.[Game Id]=?"  & vbCrLf & _
		" ORDER BY C.[Chapter Id], P.[Page Id]"
	.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameId)	
	With .Execute
		Do While Not .EOF
			Response.Write "<option "
			If .Fields("Page ID") = DefaultDestination Then Response.Write " selected='true' "
			Response.Write "value=""" & .Fields("Page ID").Value & """>" & _
				.Fields("Title").Value & "</option>"
		  .MoveNext()
		Loop
	End With 	
End With
%> 
            </select> 

	<%If scriptingLevel <> "Disabled" Then %>
	<h2 style="margin-top:20px;">Item Script</h2>
	<p style="margin-top: 0px; " class="smallerText">
	The Item Script is run just prior to directing the player to the page specified in the Item Effects.</p>
	<pstyle="margin-top: 0px; "><a href="JavaScript:editItemScript(<%=GameID%>,<%=ItemID%>);">[edit item script]</a></p>
	<% End IF %>
		
            <br/> 
            <br/> 
            <input type="button" value="Save Changes & Return to Items" onClick="PostBack('save');"> 
            <input type="hidden" name="Destination" value=""> 			
            <input type="hidden" name="pbAction" value=""> 
            <input type="hidden" name="pbValue" value=""> 
            <input type="hidden" name="postback" value="<%=Request.ServerVariables("SCRIPT_NAME") %>" />
            <input type="hidden" name="GameID" value="<%=GameID%>"> 
            <input type="hidden" name="ItemID" value="<%=ItemID%>"> 			
          </form> 
        </div> 
<% Server.Execute(Application("SiteRoot") & "Includes/footer.asp") %>
<% Conn.Close 

Sub SaveEffect ( GameId, ItemId, PageId, Destination )
	If Destination="" Or Not IsNumeric(Destination) Then Destination = Null
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandType = adCmdStoredProc
		.CommandText = "[Create or Update Item Effect]"
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)	
		.Parameters.Append .CreateParameter("ItemId",adInteger,adParamInput,4,ItemId)	
		.Parameters.Append .CreateParameter("PageId",adInteger,adParamInput,4,PageId)			
		.Parameters.Append .CreateParameter("Destination",adInteger,adParamInput,4,Destination)					
		.Execute
	End With			
End Sub 

Sub DeleteEffect( GameId, ItemId, PageId )
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = _
			"DELETE FROM [Game Item Effects] " & _
			" WHERE [Game Id] = ? " & _
			"   AND [Item Id] = ? " & _
			"   AND [Page Id] = ? "
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)	
		.Parameters.Append .CreateParameter("ItemId",adInteger,adParamInput,4,ItemId)	
		.Parameters.Append .CreateParameter("PageId",adInteger,adParamInput,4,PageId)			
		.Execute
	End With		
End Sub

Sub Save()

	If ItemID = 0 Then
		With Server.CreateObject("ADODB.Command")
			.ActiveConnection = Conn
			.CommandType = adCmdStoredProc
			.CommandText = "[Create New Item]"
			.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)	
			.Parameters.Append .CreateParameter("Title",adVarChar,adParamInput,250,Request.Form("Title"))
			.Parameters.Append .CreateParameter("Description",adLongVarChar,adParamInput,2147483647,Request.Form("Description"))		
			.Parameters.Append .CreateParameter("ItemId",adInteger,adParamOutput,4,ItemId)	
			.Execute
			ItemId = .Parameters("ItemId").Value
		End With
	End If
			
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = _
			"UPDATE [Game Items] " & _
			"   SET [Page Id] = ?, " & _
			"       [Title] = ?, " & _
			"       [Description] = ?, " & _			
			"       [Image Id] = ?, " & _						
			"       [Number of Uses] = ?, " & _						
			"       [Is Droppable] = ?, " & _						
			"       [Default Destination] = ?, " & _
			"       [Default Destination Type] = ? " & _			
			" WHERE [Game Id] = ? " & _
			"   AND [Item Id]= ? "
		.Parameters.Append .CreateParameter("Page Id",adInteger,adParamInput,4,NullIf(Request.Form("Page ID")))

		.Parameters.Append .CreateParameter("Title",adVarChar,adParamInput,250,Request.Form("Title"))
		.Parameters.Append .CreateParameter("Description",adLongVarChar,adParamInput,2147483647,Request.Form("Description"))		

		.Parameters.Append .CreateParameter("Image ID",adInteger,adParamInput,4,NullIf(Request.Form("Image Id")))
		.Parameters.Append .CreateParameter("Number of Uses",adInteger,adParamInput,4,NullIf(Request.Form("Number of Uses")))
		.Parameters.Append .CreateParameter("IIs Droppable",adInteger,adParamInput,4,Request.Form("Is Droppable"))
		.Parameters.Append .CreateParameter("Default Destination",adInteger,adParamInput,4,NullIf(Request.Form("Default Destination")))
		.Parameters.Append .CreateParameter("Default Destination Type",adVarChar,adParamInput,15)				
		If IsNull(.Parameters("Default Destination").Value) Then
			 .Parameters("Default Destination Type").Value = Null
		Else
			 .Parameters("Default Destination Type").Value = "Page"
		End If		

		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)	
		.Parameters.Append .CreateParameter("ItemId",adInteger,adParamInput,4,ItemId)	

		.Execute
	End With

End Sub

Function NullIf(s)
	If IsEmpty(s) Then
		NullIf = Null
	ElseIf s = "" Then
		NullIf = Null
	Else
		NullIf = s
	End If
End Function


%>
<script runat="server" language="jscript">
function CreateDataGrid(Conn, GameId, ItemId)
{
	var cmd = new ActiveXObject("ADODB.Command");
	
	cmd.ActiveConnection = Conn;
	cmd.CommandText = 
			"SELECT NULL AS [Edit Button], " +			
			"       NULL AS [Delete Button], " +
			"       P.[Page Id], " +
			"       P.[Title] [Page Used On], " +
			"       CASE WHEN DP.[Title] IS NULL THEN '&lt;None, Cant Use Item Here&gt;' " +
			"            ELSE DP.[Title] END [Destination] " +
			"  FROM [Game Item Effects] E " +
			"	   INNER JOIN [Game Pages] P " +
			"			   ON E.[Game Id] = P.[Game Id] " +
			"			  AND E.[Page Id] = P.[Page Id] " +
			"		LEFT JOIN [Game Pages] DP " +
			"			   ON E.[Game Id] = DP.[Game Id] " +
			"			  AND E.[Destination] = DP.[Page Id] " +
			"			  AND E.[Destination Type] = 'Page' " +
			" WHERE E.[Game Id] = ? " +
			"   AND E.[Item Id] = ?";
	cmd.Parameters.Append( cmd.CreateParameter("GameId", adInteger, adParamInput, 4, GameId) );
	cmd.Parameters.Append( cmd.CreateParameter("ItemId", adInteger, adParamInput, 4, ItemId) );	

	var dg = new DataGrid(cmd.Execute);
	dg.Display2 = dg.Display;
	dg.Display = function() { if (!this.DataSource.EOF) this.Display2(); }
	dg.Columns["Page Id"].Visible = false;

	dg.Columns["Edit Button"].HeadingText = '';
	dg.Columns["Edit Button"].RenderText = function() 
	{ 
		return '<img src="images/edit.gif" width="12" height="12" style="cursor:pointer;" alt="Edit Effect"' +
				' onclick="editEffectPopup(' + GameId +  ',' + ItemId + ',' + dg.Columns["Page Id"].GetValue() + ');">';
	}

	
	dg.Columns["Delete Button"].HeadingText = '';
	dg.Columns["Delete Button"].RenderText = function() 
	{ 
		return '<img src="images/delete.gif" width="12" height="12" style="cursor:pointer;" alt="Delete Effect" ' +
				'onclick="' +
				"if (confirm('Are you sure you want to delete this effect?\\n\\nThis cannot be undone.')) PostBack('delete_effect','" + dg.Columns["Page Id"].GetValue() + "');" +
			'">'
	}
	
	dg.Columns["Page Used On"].HeadingAlign='left';
	dg.Columns["Page Used On"].CssClass ='smallerText';

	dg.Columns["Destination"].HeadingAlign='left';	
	dg.Columns["Destination"].CssClass ='smallerText';	
	dg.AlternatingBgColor='#FFF3E5';
	dg.BgColor='#FFFBF4';	
	return dg;

}
</script>