<%@ Page Language="C#" AutoEventWireup="true" Title="Advanced Editor" %>

<%@ Register TagPrefix="cys"
    Namespace="ChooseYourStory.Web.Controls"
    Assembly="ChooseYourStory" %>
<asp:Content ContentPlaceHolderID="HeaderContentPlaceHolder" runat="server">
    <script src="common.js"></script>
    <script>
        function createNewPage() {
            var name;
            name = prompt('Enter a name for the new Page', 'New Page');
            if (!name) return;

            PostBack('create_page', name.substring(0, 250));

        }
        function createNewChapter() {
            var name;
            name = prompt('Enter a name for the new Chapter', 'New Chapter');
            if (!name) return;

            PostBack('create_chapter', name.substring(0, 50));
        }

        function editPage(GameId, PageId) {
            var url = "/advanced_editor/" + GameId + "/storypage?pageId=" + PageId
            var win = window.open(url, "_blank");
            if (!win) {
                alert('I tried to pop-up the Page Editor window but was blocked!\n\n' +
                    'You need to disable pop-up blockers in order for the advanced editor\n' +
                    'to work properly. Don\'t worry, there are no pop-up ads here.');
            }
        }
</script>
</asp:Content>
<asp:Content ContentPlaceHolderID="MainContentPlaceHolder" runat="Server">
    <cys:AspPage runat="server" Url="chapters.asp" CopyQueryString="true" CopyForm="true" />
</asp:Content>
