<% Option Explicit %>
<!-- #include file="../../../Includes/Request_Start.inc.asp" -->
<script runat="server" language="vbscript" src="../../../Includes/sessionValidator.vbs"></script>
<script runat="server" language="vbscript" src="../../../Includes/ClientMessages.vbs"></script>
<script runat="server" language="vbscript" src="../duel.vbs"></script>
<%

ValidateSession

Dim DuelId
DuelId = Clng(Request.QueryString("DuelId"))

Dim Target
Target = Request.QueryString("target")
If Target="" Then Target = Request.Form("Target")
If Target="" Then Target = "."

Dim myDuel : Set myDuel = New Duel
If Not myDuel.Load(DuelId) Then Response.Redirect Target

%>
<h2><%=myDuel.DuelType%> Duel</h2>
<%


Function Cardnalize(num)
	Cardnalize = num
	Select Case CStr(Right(num,1))
		Case "1" : Cardnalize = Cardnalize & "st"
		Case "2" : Cardnalize = Cardnalize & "nd"
		Case "3" : Cardnalize = Cardnalize & "rd"		
		Case Else : Cardnalize = Cardnalize & "th"		
	End Select
End Function
Dim IsChallenger : IsChallenger = myDuel.ChallengerUsername = Session("Username")
Dim IsChallengee : IsChallengee = myDuel.ChallengeeUsername = Session("Username")

Dim Challenger, Challengee
If IsChallenger Then Challenger = "you" Else Challenger = myDuel.ChallengerUsername
If IsChallengee Then Challengee = "you" Else Challengee = myDuel.ChallengeeUsername

Dim Points
If myDuel.Wager > 1 Then Points = myDuel.Wager & " points" Else Points = myDuel.Wager & " point"
%>
<p>It was quiet <%=WeekdayName(Weekday(myDuel.DuelDate))%>, just like every other 
<%=WeekdayName(Weekday(myDuel.DuelDate))%>, when <%=Challenger%> jumped out of
nowhere and shouted "on this <%=Cardnalize(DatePart("d",myDuel.DuelDate))%> day of <%=MonthName(Month(myDuel.DuelDate))%>
in the year <%=DatePart("yyyy",myDuel.DuelDate)%>, I challenge you, <%=myDuel.ChallengeeUsername%>, 
to a duel of Rock Paper Scissors!"</p>

<% If myDuel.Status = "Open" Then %>
  <% If IsChallengee  Then %>
    <p>There you stood, shocked that <%=myDuel.ChallengerUsername%> had actually challenged you to a duel. 
	<em>I didn't even know people still did that,</em> you thought. The stakes were high: if you won 
	the duel, you stood to gain <%=myDuel.Wager%> point<%If myDuel.Wager>1 Then Response.Write "s " Else Response.Write " "%>. 
	A loss, however, would cost you that same amount of points. How did you respond?
	</p>
    <ul>
	  <li><a href="rockpaperscissors/acceptDuel.aspx?<%=Request.QueryString()%>">Let's duel, <%=myDuel.ChallengerUsername%>!</a></li>
	  <li><a href="decline.asp?<%=Request.QueryString()%>" onClick="return (confirm('Are you sure you want to turn down the duel?'))">I humbly decline your challenge</a></li>
	</ul>

  <% Else %>	
	<p><%=myDuel.ChallengeeUsername%> has not yet accepted the challenge, but the wager is 
	high. <%=myDuel.Wager%> point<%If myDuel.Wager>1 Then Response.Write "s " Else Response.Write " "%> 
	will change hands at the completion of this duel. That is, if <%=myDuel.ChallengeeUsername%> 
	chooses to accept. Stay tuned as more events unfold.
	</p>
	<p><input type="button" onClick="location=this.form.Target.value" value="Go Back"/></p>
  <% End If %>
<% ElseIf myDuel.Status="Declined" Then %>
	<p>However, <%=Challengee%> stood firm and declined the challenge. Perhaps the 
	wager of <%=myDuel.Wager%> point<%If myDuel.Wager>1 Then Response.Write "s " Else Response.Write " "%> 
	was too high or maybe it seemed to barbaric of a practice. For whatever reason,
	no duel took place on that day.
	</p>
	<p><input type="button" onClick="location=this.form.Target.value" value="Go Back"/></p>
<% ElseIf myDuel.Status="Complete" Then %>	
    <p>In response to the challenge, <%=Challengee%> bravely accepted and began the battle. 
	<%=Challenger%>, the challenger, chose <%=myDuel.ChallengerChoice%>, while <%=Challengee%>, 
	the defender, chose <%=myDuel.ChallengeeChoice%>.
	<% If myDuel.Winner="Draw" Then %>
	  Clearly, both sides were evenly matched: the duel resulted in a draw. No points exchanged
  	  hands this time. But maybe, just maybe, another duel will be called ...
	<% ElseIf myDuel.Winner="Challenger" Then %>
	  As <%=Challenger%> expected, the challenger prevailed. <%=Challengee%> lost the match,
	  forfeiting a good <%=Points%>.
	<% ElseIf myDuel.Winner="Challengee" Then %>
	  An outcome that will be regretted by the the challenger for a long time,
	  <%=Challengee%> prevailed and received <%=Points%> from <%=Challenger%>.
	<% End If %>
	<p>
	  <input type="button" onClick="location=this.form.Target.value" value="Go Back"/>
	  <% If myDuel.ChallengerUsername = Session("Username") Then %>
	    &nbsp;&nbsp;
	    <input type="button" onclick="location='selectDuel.aspx?Username=<%=Server.URLEncode(Challengee)%>'" value="Challenge <%=Challengee%> To A Duel"/>	    
	  <% ElseIf myDuel.ChallengeeUsername = Session("Username") Then %>	
	    &nbsp;&nbsp;	  
	    <input type="button" onclick="location='selectDuel.aspx?Username=<%=Server.URLEncode(Challenger)%>'" value="Challenge <%=Challenger%> To A Duel"/>	    
	  <% End If %>
	</p>
	
<% End If %>
<input type="hidden" name="Target" value="<%=Server.HTMLEncode(Target)%>">